unit Udaviewer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, ExtDlgs;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Image1: TImage;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    MainMenu1: TMainMenu;
    MILoad: TMenuItem;
    MISave: TMenuItem;
    MIOpenImg: TMenuItem;
    PictureDlg: TOpenPictureDialog;
    procedure MILoadClick(Sender: TObject);
    procedure MISaveClick(Sender: TObject);
    procedure MIOpenImgClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure updimg (var bmp : tbitmap);
    procedure FormCreate(Sender: TObject);
  public
  procedure load (fname : string);
  procedure save (fname : string);
  end;

datype = record
  offset : integer;
  text : ansistring;
  bmp : tbitmap;
  end; 

var
  da : datype;
  intsz : byte = sizeof(da.offset);
  Form1: TForm1;
  fs : tfilestream;
  ms :  tmemorystream ;
  ext : string = 'bin';
  appname : string = 'DaViewer';

implementation

{$R *.dfm}

procedure TForm1.load (fname : string);
var i : integer;
ch : char;
begin
fs := tfilestream.create(fname, fmopenread);
fs.read(da.offset, intsz);
ms := tmemorystream.create;
da.text  := '';
for i := 0 to da.offset-1
  do begin
  fs.Read(ch,1) ;
  da.text  := da.text + ch;
  end;
da.bmp := tbitmap.create;
da.bmp.loadfromstream(fs);
freeandnil(ms);
freeandnil(fs);
updimg(da.bmp);
memo1.Text := da.text;
end;

procedure TForm1.MILoadClick(Sender: TObject);
begin
if opendlg.Execute
  then load(opendlg.FileName);
end;

procedure TForm1.save(fname: string);
var i,j : integer;
begin
fs := tfilestream.create(fname, fmcreate);
fs.seek(intsz, sofromcurrent);
da.text := memo1.Text ;
j:= length(da.text) ;
for i := 1 to j
  do fs.write(copy(da.text,i,1)[1], 1);
da.offset := fs.position - intsz ;
da.bmp.SaveToStream(fs);
fs.seek(0, sofrombeginning);
fs.write(da.offset, intsz);
freeandnil(fs);
end;

procedure TForm1.MISaveClick(Sender: TObject);
begin
if (da.bmp <> nil) and (savedlg.Execute)
  then save(savedlg.FileName);
end;

procedure TForm1.MIOpenImgClick(Sender: TObject);
begin
if picturedlg.Execute
  then begin
  da.bmp :=TBitmap.Create;
  fs := tfilestream.Create(picturedlg.FileName, fmopenread);
  da.bmp.LoadFromstream(fs);
  da.offset := fs.Size;
  freeandnil(fs);
  updimg(da.bmp);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
freeandnil(da.bmp);
end;

procedure TForm1.updimg(var bmp: tbitmap);
begin
image1.Width := bmp.Width;
image1.height := bmp.height;
image1.Canvas.Draw(0,0,bmp);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
opendlg.Filter := ext + ' file(*.' + ext + ')|*.' + ext ;
savedlg.Filter := ext + ' file(*.' + ext + ')|*.' + ext ;
opendlg.DefaultExt := ext;
savedlg.DefaultExt := ext;
caption := appname;
application.Title := appname;
end;

end.
